package com.push.democlient;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;

import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;


import androidx.localbroadcastmanager.content.LocalBroadcastManager;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.Map;

import m.client.push.library.PushHandler;
import m.client.push.library.PushManager;
import m.client.push.library.common.Logger;
import m.client.push.library.common.PushConstants;
import m.client.push.library.common.PushConstantsEx;
import m.client.push.library.common.PushLog;
import m.client.push.library.common.PushServiceInfo;

import m.client.push.library.service.GCMReceiverService;
import m.client.push.library.service.LogNetworkManager;
import m.client.push.library.utils.PushUtils;

public class LoginActivity extends Activity {

	private BroadcastReceiver mLoginBroadcastReceiver;

	private EditText mLoginIdEdit;
	private EditText mPasswordEdit;
	private Button mLoginBtn;
	SharedPreferences pref;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		/*Intent it = getIntent();
		if (it != null) {
			String notification = it.getStringExtra("payload");
			String seqNo = it.getStringExtra("seqno");

			if (notification != null && seqNo != null) {
				//데이터 전달 관련 비즈니스 로직 구현
				createConfirmDialog(this, "알림 " + seqNo, notification);
			}
		}*/
		pref = getSharedPreferences(getPackageName()+PushConstants.PUSH_CONFIG_FILE_NAME,MODE_PRIVATE);

		// 화면 구성
		setContentView(R.layout.activity_login);
		// 화면 위젯 초기화 및 이벤트 등록
		mLoginIdEdit = (EditText) LoginActivity.this.findViewById(R.id.edit_id);
		mPasswordEdit = (EditText) LoginActivity.this.findViewById(R.id.edit_pw);
		mLoginIdEdit.setText("test1");
		mPasswordEdit.setText("1111");
		Log.e("cuid::",PushUtils.getStringFromStorage(PushConstants.KEY_CUID, getApplicationContext()));

		mLoginBtn = (Button) this.findViewById(R.id.button_login);
		mLoginBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				// 로그인 시 유효성 체크
				if (mLoginIdEdit == null || mLoginIdEdit.getText().toString().length() < 0) {
					Toast.makeText(LoginActivity.this, "아이디를 입력하세요.", Toast.LENGTH_SHORT).show();
					return;
				}
				if (mPasswordEdit == null || mPasswordEdit.getText().toString().length() < 0) {
					Toast.makeText(LoginActivity.this, "비밀번호를 입력하세요.", Toast.LENGTH_SHORT).show();
					return;
				}

				// 필수 데이터 구성 - Client ID 와 Client Name 으로 User 등록
				final JSONObject params = new JSONObject();
				try {
					params.put(PushConstants.KEY_CUID, mLoginIdEdit.getText().toString());
					params.put(PushConstants.KEY_CNAME, mLoginIdEdit.getText().toString());
				}
				catch (JSONException e) {
					e.printStackTrace();
				}


				// 서비스 등록 및 사용자 등록을 함께 진행할 시 이용하는 API
				// 별도의 서비스 등록이 필요 없고 사용자 등록 시에 해당 API를 통해 서비스 등록_사용자 등록을 진행
				// http://docs.morpheus.co.kr/client/push/gcm.html#service 참고.


				if(PushUtils.checkNetwork(LoginActivity.this)){
					new Handler().post(new Runnable() {

						@Override
						public void run() {
							PushManager.getInstance().registerServiceAndUser(LoginActivity.this, params);
						}
					});
				}else{
					Log.e("MainActivity", "network is not connected.");
					Toast.makeText(LoginActivity.this, "[MainActivity] network is not connected.", Toast.LENGTH_SHORT).show();
				}
			}
		});

		Button logoutBtn = (Button)this.findViewById(R.id.button_loginout);
		logoutBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				if (mLoginIdEdit == null || mLoginIdEdit.getText().toString().length() < 0) {
					Toast.makeText(LoginActivity.this, "아이디를 입력하세요.", Toast.LENGTH_SHORT).show();
					return;
				}

				if(PushUtils.checkNetwork(LoginActivity.this)){
					new Handler().post(new Runnable() {

						@Override
						public void run() {
							// TODO Auto-generated method stub
							// 푸시 서비스 등록 해제 - 서비스 및 사용자가 해제
							PushManager.getInstance().unregisterPushService(getApplicationContext());
						}
					});
				}else{
					Log.e("MainActivity", "network is not connected.");
					Toast.makeText(LoginActivity.this, "[MainActivity] network is not connected.", Toast.LENGTH_SHORT).show();
				}
			}
		});

		// 화면 레이아웃 설정
		setLogin();
	}

	@Override
	protected void onResume() {
		super.onResume();

		registerReceiver();
	}

	@Override
	protected void onPause() {
		super.onPause();

		unregisterReceiver();

		Intent it = getIntent();
		String notification = it.getStringExtra("JSON");
		JSONObject payload = new JSONObject();
		if (notification!=null) {
			try {
				payload.put("status", "SUCCESS");
				payload.put("payload", notification);
				//데이터 전달 관련 비즈니스 로직 구현
				Log.e("LOGIN1ACTIVITY_onPause", notification);
			} catch (JSONException e) {

			}
		}
	}

	@Override
	public void onBackPressed() {
		LinearLayout sendTestLayout = this.findViewById(R.id.layout_send);
		if (sendTestLayout != null && sendTestLayout.getVisibility() == View.VISIBLE) {
			setLayout(true);
			deletedata(this,pref);
		}else{
			super.onBackPressed();
		}
	}

	public void registerReceiver() {
		if (mLoginBroadcastReceiver != null) {
			return;
		}

		// 푸시 API 결과를 받기 위한 인텐트 필터 설정
		IntentFilter intentFilter = new IntentFilter();
		intentFilter.addAction(LoginActivity.this.getPackageName()  + ".ACTION_COMPLETED");

		mLoginBroadcastReceiver = new BroadcastReceiver() {

			@Override
			public void onReceive(Context context, Intent intent) {

				// 액션 유효성 체크
				// 수신된 인텐트(결과값 응답) 의 정상 데이터 여부 체크 (푸시 타입/액션 타입) - 반드시 구현
				if (!PushUtils.checkValidationOfCompleted(intent, context)) {
					return;
				}

				String result = intent.getExtras().getString("RESULT");
				String bundle = intent.getExtras().getString("BUNDLE");

				JSONObject result_obj = null; // 결과 오브젝트
				//intent 정보가 정상적인지 판단
				String resultCode = ""; // 결과 코드
				String resultMsg = ""; // 결과 메세지
				try {
					result_obj = new JSONObject(result);
					resultCode = result_obj.getString("RESULT_CODE");
					resultMsg = result_obj.getString("RESULT_MSG");

					String resultBody = result_obj.optString(PushConstants.KEY_BODY);
					Log.e("resultBody::",resultBody);
					//Logger.e(new JSONArray(resultBody).getJSONObject(0).getString("DEVICEID_CHANGE_YN"));
					//Log.e("DEVICEID_CHANGE_YN::", new JSONArray(resultBody).getJSONObject(0).getString("DEVICEID_CHANGE_YN"));
				}
				catch (JSONException e) {
					e.printStackTrace();
				}

				// 액션에 따라 분기 처리
				// 사용자 등록 결과 처리
				if (bundle.equals(".REG_USER")) {
					if (resultCode.equals("200")) {
						Toast.makeText(context, "로그인 성공!", Toast.LENGTH_SHORT).show();
						setSendTest();
					}
					else {
						Toast.makeText(context, "[LoginActivity] error code: " + resultCode + " msg: " + resultMsg, Toast.LENGTH_SHORT).show();
					}
				}

				// 서비스 및 사용자 등록 API를 사용했을 경우
				else if(bundle.equals(".REG_SERVICE_AND_USER")) {
					if (resultCode.equals("200")) {
						Toast.makeText(context, "로그인 성공!", Toast.LENGTH_SHORT).show();
						setSendTest();
					}
					else {
						Toast.makeText(context, "[LoginActivity] error code: " + resultCode + " msg: " + resultMsg, Toast.LENGTH_SHORT).show();
						deletedata(getApplicationContext(),pref);
					}
				}
				// 푸시 서비스 해제
				else if (bundle.equals(PushConstantsEx.COMPLETE_BUNDLE.UNREG_PUSHSERVICE)) {

					if (resultCode.equals(PushConstants.SUCCESS_RESULT_CODE)) {
						Toast.makeText(context, "해제 성공!", Toast.LENGTH_SHORT).show();
					}
					else {
						Toast.makeText(context, "[LoginActivity] error code: " + resultCode + " msg: " + resultMsg, Toast.LENGTH_SHORT).show();
					}
				}
				// 그룹 등록
				else if (bundle.equals(PushConstantsEx.COMPLETE_BUNDLE.REG_GROUP)) {

					if (resultCode.equals(PushConstants.SUCCESS_RESULT_CODE)) {
						Toast.makeText(context, "그룹 등록 성공!", Toast.LENGTH_SHORT).show();
					}
					else {
						Toast.makeText(context, "[LoginActivity] error code: " + resultCode + " msg: " + resultMsg, Toast.LENGTH_SHORT).show();
					}
				}
				// 그룹 해제
				else if (bundle.equals(PushConstantsEx.COMPLETE_BUNDLE.UNREG_GROUP)) {

					if (resultCode.equals(PushConstants.SUCCESS_RESULT_CODE)) {
						Toast.makeText(context, "그룹 해제 성공!", Toast.LENGTH_SHORT).show();
					}
					else {
						Toast.makeText(context, "[LoginActivity] error code: " + resultCode + " msg: " + resultMsg, Toast.LENGTH_SHORT).show();
					}
				}
				// 뱃지 초기화 - 안드로이드 기본 기능으로 제공되는 것이 아니므로
				// 뱃지 카운트를 서버를 통해 초기화 및 업데이트를 진행하고 이에 대해 디바이스에 적용해준다.
				else if (bundle.equals(PushConstantsEx.COMPLETE_BUNDLE.INITBADGENO)) {

					if (resultCode.equals(PushConstants.SUCCESS_RESULT_CODE)) {
						Toast.makeText(context, "Badge Number 초기화 성공 !", Toast.LENGTH_SHORT).show();
						// 초기화 성공 시 실제 디바이스의 뱃지 값을 변경하여 준다.
						PushManager.getInstance().setDeviceBadgeCount(getApplicationContext(), "11");
					}
					else {
						Toast.makeText(context, "[LoginActivity] error code: " + resultCode + " msg: " + resultMsg, Toast.LENGTH_SHORT).show();
					}
				}
				// 이미 등록되어 있다면
				else if (bundle.equals(PushConstantsEx.COMPLETE_BUNDLE.IS_REGISTERED_SERVICE)) {
					String isRegister = "";
					try {
						isRegister = result_obj.getString(PushConstants.KEY_ISREGISTER);
					} catch (JSONException e) {
						e.printStackTrace();
					}

					if (isRegister.equals("C")) {
						Toast.makeText(context, "CHECK ON [ 사용자 재등록 필요 !! ]", Toast.LENGTH_LONG).show();
					}
					else if(isRegister.equals("N")) {
						Toast.makeText(context, "CHECK ON [ 서비스 재등록 필요 !! ]", Toast.LENGTH_LONG).show();
					}
					else {
						Logger.i("서비스 정상 등록 상태 ");
					}
				}
			}
		};

		LocalBroadcastManager.getInstance(this).registerReceiver(mLoginBroadcastReceiver, intentFilter);
	}

	public void unregisterReceiver() {
		if (mLoginBroadcastReceiver != null) {
			LocalBroadcastManager.getInstance(this).unregisterReceiver(mLoginBroadcastReceiver);
			mLoginBroadcastReceiver = null;
		}
	}

	private void setLayout(boolean isLogin) {
		LinearLayout loginLayout = (LinearLayout)this.findViewById(R.id.layout_login);
		LinearLayout sendTestLayout = (LinearLayout)this.findViewById(R.id.layout_send);
		Button pushListBtn = (Button)this.findViewById(R.id.button_list);
		//Button changeTypeBtn = (Button)this.findViewById(R.id.button_change_type);

		if (isLogin) {
			loginLayout.setVisibility(View.VISIBLE);
			sendTestLayout.setVisibility(View.GONE);
			pushListBtn.setVisibility(View.GONE);
			//changeTypeBtn.setVisibility(View.GONE);
		}
		else {
			loginLayout.setVisibility(View.GONE);
			sendTestLayout.setVisibility(View.VISIBLE);
			pushListBtn.setVisibility(View.VISIBLE);
			//changeTypeBtn.setVisibility(View.VISIBLE);
		}

		pushListBtn.setOnClickListener(v -> startActivity(new Intent(LoginActivity.this, PushListActivity.class)));
	}

	private void setLogin() {
		setLayout(true);

		mLoginIdEdit.clearComposingText();
		mPasswordEdit.clearComposingText();
	}

	private void setSendTest() {
		setLayout(false);
		//REGISTER_SERVICE_AND_USER
		Button send1Btn = (Button)this.findViewById(R.id.button_send1);
		Button send2Btn = (Button)this.findViewById(R.id.button_send2);
		Button send3Btn = (Button)this.findViewById(R.id.button_send3);
		Button send4Btn = (Button)this.findViewById(R.id.button_send4);
		Button send5Btn = (Button)this.findViewById(R.id.button_send5);
		send1Btn.setTag(1);
		send2Btn.setTag(2);
		send3Btn.setTag(3);
		send4Btn.setTag(4);
		send5Btn.setTag(5);
		send1Btn.setOnClickListener(mSendButtonClickListener);
		send2Btn.setOnClickListener(mSendButtonClickListener);
		send3Btn.setOnClickListener(mSendButtonClickListener);
		send4Btn.setOnClickListener(mSendButtonClickListener);
		send5Btn.setOnClickListener(mSendButtonClickListener);

		send5Btn.setVisibility(View.GONE);// 푸시 서비스 해제 요청
		Button unregisterBtn = (Button)this.findViewById(R.id.button_del);
		unregisterBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {

				if(PushUtils.checkNetwork(LoginActivity.this)){
					new Handler().post(new Runnable() {

						@Override
						public void run() {
							// TODO Auto-generated method stub
							// 푸시 서비스 등록 해제 - 서비스 및 사용자가 해제
							PushManager.getInstance().unregisterPushService(LoginActivity.this);
							setLayout(true);
							deletedata(LoginActivity.this,pref);
						}
					});
				}else{
					PushLog.e("MainActivity", "network is not connected.");
					Toast.makeText(LoginActivity.this, "network is not connected.", Toast.LENGTH_SHORT).show();
				}
			}
		});

		// 푸시 사용자 해제 요청
		Button subscribeBtn = (Button)this.findViewById(R.id.button_subscribe);
		subscribeBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {

				if(PushUtils.checkNetwork(LoginActivity.this)){
					new Handler().post(new Runnable() {

						@Override
						public void run() {
							// TODO Auto-generated method stub
							PushManager.getInstance().unregisterPushUser(LoginActivity.this, mLoginIdEdit.getText().toString(), mLoginIdEdit.getText().toString());
						}
					});
				}else{
					PushLog.e("MainActivity", "network is not connected.");
					Toast.makeText(LoginActivity.this, "network is not connected.", Toast.LENGTH_SHORT).show();
				}
				//
			}
		});

		// 뱃지 초기화 요청
		Button initBadgeBtn = (Button)this.findViewById(R.id.button_initBadgeNo);
		initBadgeBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				if(PushUtils.checkNetwork(LoginActivity.this)){
					new Handler().post(new Runnable() {

						@Override
						public void run() {
							// TODO Auto-generated method stub
							PushManager.getInstance().initBadgeNo(LoginActivity.this.getApplicationContext(), "10");
						}
					});
				}else{
					PushLog.e("MainActivity", "network is not connected.");
					Toast.makeText(LoginActivity.this, "network is not connected.", Toast.LENGTH_SHORT).show();
				}
			}
		});
	}

	// 메세지 전송
	private void sendPushMessage(int type) {
		String message = "일반 알림";
		String ext = "메세지 테스트";
		if (type == 2) {
			message = "Web 알림";
			ext = "1|웹페이지|http://lab.morpheus.kr/push/sample/image|http://lab.morpheus.kr/push/sample/webpage";
		}
		else if (type == 3) {
			message = "동영상 알림";
			ext = "1|웹페이지|http://lab.morpheus.kr/push/sample/image|https://youtu.be/IIu0VMdOe10";
		}
		else if (type == 4) {
			message = "이미지 알림";
			ext = "1|웹페이지|http://lab.morpheus.kr/push/sample/image"; // 파라메터 갯수로 구분
		}

		Log.d("TEST", "login_btn >> sendPushMessage PushManager.getInstance().sendPushMessage");


		//service type은 서버 규약에 따름 upns 발송시 사용- 테스트 서버 기준 (GCM/ APNS 발송)
		//PushManager.getInstance().sendPushMessage(getApplicationContext(), message, ext, "", "0001");

		//service type은 서버 규약에 따름 upns 발송시 사용- 테스트 서버 기준 (gcm => dumy (doze mode), upns : 실발송 )

		if(PushUtils.checkNetwork(LoginActivity.this)){
			final String finalMessage = message;
			final String finalExt = ext;
			new Handler().post(new Runnable() {

				@Override
				public void run() {
					// TODO Auto-generated method stub
					PushManager.getInstance().sendPushMessage(getApplicationContext(), finalMessage, finalExt, "test1", "PRIVATE");
				}
			});
		}else{
			PushLog.e("MainActivity", "network is not connected.");
			Toast.makeText(LoginActivity.this, "network is not connected.", Toast.LENGTH_SHORT).show();
		}


	}

	private View.OnClickListener mSendButtonClickListener = new View.OnClickListener() {
		@Override
		public void onClick(View v) {
			int type = (Integer) v.getTag();
			sendPushMessage(type);
		}
	};

	public static void deletedata(Context context, SharedPreferences pref){
		SharedPreferences.Editor editor = pref.edit();
		editor.remove(PushConstants.KEY_EDIT_PUSH_TYPE);
		boolean isSaved = editor.commit();
		Log.d("deletedata::", String.valueOf(isSaved));
	}
}
