package com.push.democlient;

import java.util.ArrayList;
import java.util.Arrays;

import m.client.push.library.PushManager;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.text.TextUtils;

public class PushMessageActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		String jsonMessage = this.getIntent().getStringExtra("JSON");
		String message = this.getIntent().getStringExtra("EXT");
		String title = this.getIntent().getStringExtra("TITLE");

		try {
			JSONObject jsonMsg = new JSONObject(jsonMessage);
			final String SEQNO = jsonMsg.optString("SEQNO");
	    	PushManager.getInstance().pushMessageReadConfirm(this, jsonMessage);

			ArrayList<String> params = null;
			if (message != null) {
				String[] paramArray = message.split("\\|");
				params = new ArrayList<String>(Arrays.asList(paramArray));
			}

			if (params != null && params.size() > 0) {
				if (params.get(0).equals("0")) {
					Intent intent = new Intent(this, PushDetailActivity.class);
					intent.putExtra("JSON", jsonMsg.toString());
					intent.putExtra("type", params.get(0));
					intent.putExtra("title", title);
			    	intent.putExtra("message", params.get(1));
					intent.putExtra("seq",SEQNO);
			    	startActivity(intent);
				}
				else if (params.get(0).equals("1")) {
				try {

				}catch (Exception e){

				}

					String contentUrl = "";
					if(params.size() > 3){
						contentUrl = params.get(3);
					}
					if (TextUtils.isEmpty(contentUrl)) { // 단순 이미지만 존재하는 메세지
						Intent intent = new Intent(this, PushDetailActivity.class);
						intent.putExtra("JSON", jsonMsg.toString());
						intent.putExtra("type", params.get(0));
						intent.putExtra("title", title);
				    	intent.putExtra("message", params.get(1));
				    	intent.putExtra("img", params.get(2));
						intent.putExtra("seq",SEQNO);
				    	startActivity(intent);
					}
					else { // 컨텐츠가 있는 메세지 - 동영상/웹페이지
						Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(contentUrl));
						startActivity(intent);
					}
				}
				else { // 타입이 없는 경우 사용자 정의
					Intent intent = new Intent(this, PushDetailActivity.class);
					intent.putExtra("JSON", jsonMsg.toString());
					intent.putExtra("type", params.get(0));
					intent.putExtra("title", title);
			    	intent.putExtra("message", params.get(0));
					intent.putExtra("seq",SEQNO);
			    	startActivity(intent);
				}
			}
		}
		catch (JSONException e) {
			e.printStackTrace();
		}

		finish();
	}
}
