package com.push.democlient;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.push.democlient.common.Utils;

public class SecretMessageActivity extends Activity {
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_secret);
		
		final String url = this.getIntent().getStringExtra("url");
		String encryptData = this.getIntent().getStringExtra("ENCRYPT");
		
		if (encryptData != null) {
			TextView msgTextView = (TextView)this.findViewById(R.id.text_view_value);
			String msg = "<암호화 된 Push Message>\n\n" + encryptData;
			msgTextView.setText(msg);
			msgTextView.setVisibility(View.VISIBLE);
		}
		
		Button confirmBtn = (Button) this.findViewById(R.id.button_confirm);
		confirmBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				EditText passwordEdit = (EditText) SecretMessageActivity.this.findViewById(R.id.edit_view_pw);
				String pw = passwordEdit.getText().toString();
				String orgPasswordEdit = Utils.getConfigString(SecretMessageActivity.this, Utils.CONFIG_PASSWORD_NAME);
				
				if (orgPasswordEdit.equals(pw)) {
					Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(url));
					startActivity(intent);
				}
				else {
					Toast.makeText( getApplicationContext(), "비밀번호가 맞지 않습니다.", Toast.LENGTH_SHORT).show();
				}
			}
		});
	}
}
